routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('welcome');

Route::resource("genres", "App\Http\Controllers\GenreController");
Route::resource("authors", "App\Http\Controllers\AuthorController");
Route::resource("books", "App\Http\Controllers\BookController");

app/Models/Genre.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Genre extends Model
{
    use HasFactory;

    protected $fillable = ["nombre"];

    public function books()
    {
        return $this->hasMany("App\Models\Book", "idGenero");
    }
}

app/Http/Controllers/GenreController.php
<?php

namespace App\Http\Controllers;

use App\Models\Genre;
use App\Http\Requests\StoreGenreRequest;
use App\Http\Requests\UpdateGenreRequest;

class GenreController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('genres.index', ['genres' => Genre::get()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('genres.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreGenreRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreGenreRequest $request)
    {
        $fields = $request->validate([
            'nombre' => 'required|string'
        ]);

        Genre::create($fields);
        return redirect()->route('genres.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function show(Genre $genre)
    {
        return view('genres.show', ['genre' => $genre]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function edit(Genre $genre)
    {
        return view('genres.edit', ['genre' => $genre]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateGenreRequest  $request
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateGenreRequest $request, Genre $genre)
    {
        $fields = $request->validate([
            'nombre' => 'required|string'
        ]);

        $genre->update($fields);
        return redirect()->route('genres.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Genre  $genre
     * @return \Illuminate\Http\Response
     */
    public function destroy(Genre $genre)
    {
        $genre->delete();
        return redirect()->route('genres.index');
    }
}

resources/views/genres/create.blade.php
@extends('layout')

@section('title', 'Agregar Género')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Insertar Género</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('genres.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('genres.store') }}" method="POST">
                    @csrf

                    <label for="nombre">Nombre</label>
                    <input type="text" name="nombre" required>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/genres/edit.blade.php
@extends('layout')

@section('title', 'Modificar Género')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Modificar Género</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton" href="{{ route('genres.index') }}">Regresar</a>
        </div>
        <div class="row formulario">
            <fieldset>
                <form action="{{ route('genres.update', $genre) }}" method="POST">
                    @csrf
                    @method('PATCH')

                    <label for="id">ID</label>
                    <input type="number" name="id" value="{{ $genre->id }}" readonly>

                    <label for="nombre">Nombre</label>
                    <input type="text" name="nombre" value="{{ $genre->nombre }}" required>

                    <div class="acciones">
                        <input class="boton" type="submit" value="Guardar">
                    </div>
                </form>
            </fieldset>
        </div>
    </div>
@endsection

resources/views/genres/index.blade.php
@extends('layout')

@section('title', 'Géneros')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>Géneros</h1>
        </div>
        <div class="row acciones mb-4">
            <a class="boton me-2" href="{{ route('welcome') }}">Regresar</a>
            <a class="boton" href="{{ route('genres.create') }}">Agregar Género</a>
        </div>
        <div class="row">
            @if(!$genres->isEmpty())
                <div class="container tabla">
                    <div class="row encabezado">
                        <div class="col-12 col-md-3 columna">ID</div>
                        <div class="col-12 col-md-3 columna">Nombre</div>
                        <div class="col-12 col-md-6 columna">Acciones</div>
                    </div>
                    @foreach($genres as $genre)
                    <div class="row contenido">
                        <div class="col-12 col-md-3 columna">{{ $genre->id }}</div>
                        <div class="col-12 col-md-3 columna">{{ $genre->nombre }}</div>
                        <div class="col-12 col-md-6 acciones columna">
                            <a class="boton mostrar col" href="{{ route('genres.show', $genre) }}">Mostrar</a>
                            <a class="boton editar col" href="{{ route('genres.edit', $genre) }}">Editar</a>
                            <form class="col" action="{{ route('genres.destroy', $genre) }}" method="POST">
                                @csrf
                                @method('DELETE')
                                <input class="boton eliminar" type="submit" value="Eliminar">
                            </form>
                        </div>
                    </div>
                    @endforeach
                </div>
            @else
                <div class="col">
                    No existen géneros para mostrar
                </div>
            @endif
        </div>
    </div>
@endsection

resources/views/genres/show.blade.php
@extends('layout')

@section('title', 'Mostrar Género')

@section('content')
    <div class="container">
        <div class="row titulo">
            <h1>{{ $genre->nombre }}</h1>
        </div>
        <div class="row acciones">
            <a class="boton" href="{{ route('genres.index') }}">Regresar</a>
        </div>
    </div>
@endsection